/*
Copyright 2015-2020 Webtrends
SharePoint Loader 
Version: 4.17.0.537
*/

/**********************MANUAL TAG CONFIG START*************************/

window.wt_sp_globals = window.wt_sp_globals ? window.wt_sp_globals : {};
window.wt_sp_globals.app = true;

window.wt_sp_globals.wtManualLoadConfigs = function () {
    window.wt_sp_globals.baseTagUrl = "//s.webtrends.com/js/";
    window.wt_sp_globals.url = window.wt_sp_globals.url ? window.wt_sp_globals.url : window.wt_sp_globals.spPageContextInfo.siteAbsoluteUrl + "/WebtrendsAssets/";
    window.wt_sp_globals.app = false;
    window.wt_sp_globals.configs = {
        domain: "statse.webtrendslive.com", // SDC Server
        dcsid: "xxxxxxxxxxxxxxxxxxxxxxxxx_xxxx", // DCSID
        timezone: "-8", // Time zone
        homesite: window.wt_sp_globals.spPageContextInfo.siteAbsoluteUrl,
        downloadtypes: "xls,doc,ppt,one,pub,jpg,bmp,gif,png,wmv,mpg,mp4,avi,csv,zip,txt,rtf,ics,js,dotx,gzip,mpp,msg,oft,pdf,potx,sql,vsd,vsdx,xap,xml,xps,xsn,docx,docm,dotm,docb,xlt,xlm,xlsx,xlsm,xlsb,pptx,pptm,ppsx,ppsm,onepkg",
        i18n: false,
        preserve: true,
        debug: false,
        plugins: {
            ups: {
                src: wt_sp_globals.url + "webtrends.ups.js",
                async: false,
                waitForCallback: true,
                timeout: 7500,
                userProfile: {
                    Department: "WT.shp_dept",
                    Manager: "WT.shp_mgr",
                    PreferredName: "WT.shp_uname",
                    Office: "WT.shp_office",
                    AccountName: "WT.shp_login",
                    Title: "WT.shp_title",
                    Location: "WT.shp_location",
                    Function: "WT.shp_function"
                }
            },
            sp: {
                src: wt_sp_globals.url + "webtrends.sp.js",
                async: false,
                waitForCallback: true,
                timeout: 7500,
                overlays: {}
            },
            spsocial: {
                src: wt_sp_globals.url + "webtrends.spsocial.js",
                async: false,
                timeout: 7500,
                options: {
                    impressions: false,
                    textLength: 50
                }
            }//,
            /* // Disabled by Default.  To enabled, remove comment preceeding comma above, slash-star on this line, and star-slash below
            splc: {
                src: wt_sp_globals.url + "webtrends.splc.js",
                async: false,
                timeout: 7500
            }*/  
        }
    };

    if (typeof window.wt_sp_globals.configs.plugins.sp !== "undefined") {
        window.wt_sp_globals.configs.plugins.sp.ids = {};
        window.wt_sp_globals.configs.plugins.sp.extraUserInfo = true;
        window.wt_sp_globals.configs.plugins.sp.skipUPSInApps = false;
        window.wt_sp_globals.configs.plugins.sp.username = true;
        window.wt_sp_globals.configs.plugins.sp.ids.pritopleveluserid = "SuiteNavUserName"; // zz4_Menu for 2013
        window.wt_sp_globals.configs.plugins.sp.ids.sectopleveluserid = "zz5_Menu"; // zz5_Menu for 2013
        window.wt_sp_globals.configs.plugins.sp.userlogin = true;
        window.wt_sp_globals.configs.plugins.sp.dcsaut = true;
        window.wt_sp_globals.configs.plugins.sp.dcsautParam = "WT.shp_login";
        window.wt_sp_globals.configs.plugins.sp.dcsvid = false;
        window.wt_sp_globals.configs.plugins.sp.dcsvidParam = "WT.shp_login";
        window.wt_sp_globals.configs.plugins.sp.siteInfo = true;
        window.wt_sp_globals.configs.plugins.sp.toContent = true;
        window.wt_sp_globals.configs.plugins.sp.search = true;
        window.wt_sp_globals.configs.plugins.sp.ids.searchBox = "DataProvider";
        window.wt_sp_globals.configs.plugins.sp.ids.searchPage = "osssearchresults.aspx,results.aspx,search.aspx"; // list of search pages to check for (partial matches)
        window.wt_sp_globals.configs.plugins.sp.ids.searchResultBodyClassName = "ms-srch-item,ms-srch-bestBetItem,ms-srch-people-item,ms-srch-video-results ms-srch-video-results-container";
        window.wt_sp_globals.configs.plugins.sp.legacySearch = false;
        window.wt_sp_globals.configs.plugins.sp.bread = true;
        window.wt_sp_globals.configs.plugins.sp.ids.breadid = "DeltaPlaceHolderPageTitleInTitleArea";
        window.wt_sp_globals.configs.plugins.sp.webparts = true;
        window.wt_sp_globals.configs.plugins.sp.webPartLimit = "40";
        window.wt_sp_globals.configs.plugins.sp.webPartIds = false;
        window.wt_sp_globals.configs.plugins.sp.documentMenuClick = true;
        window.wt_sp_globals.configs.plugins.sp.documentMetadata = false;
        window.wt_sp_globals.configs.plugins.sp.documentMetadataFields = "";
        window.wt_sp_globals.configs.plugins.sp.list = true;
        window.wt_sp_globals.configs.plugins.sp.socialMenuClick = true;
        window.wt_sp_globals.configs.plugins.sp.legacySocial = false;
        window.wt_sp_globals.configs.plugins.sp.articleImpressions = false;
        window.wt_sp_globals.configs.plugins.sp.allClick = true;
        window.wt_sp_globals.configs.plugins.sp.multiTrack = false;
        window.wt_sp_globals.configs.plugins.sp.obfuscate = false;
        window.wt_sp_globals.configs.plugins.sp.obfuscateParams = "WT.shp_login,WT.shp_uname,DCS.dcsaut,WT.dcsvid,WT.shp_mgr,WT.soc_author,WT.soc_login,WT.soc_reply_author,WT.soc_reply_login,WT.soc_follow_author,WT.soc_follow_login,WT.article_author";
        window.wt_sp_globals.configs.plugins.sp.stripIP = false;
        window.wt_sp_globals.configs.plugins.sp.overwriteClientIP = false;
        window.wt_sp_globals.configs.plugins.sp.desiredIpAddress = "192.168.0.1";
        window.wt_sp_globals.configs.plugins.sp.legacyOnSite = false;
        window.wt_sp_globals.configs.plugins.sp.homedom = window.location.hostname;
        window.wt_sp_globals.configs.plugins.sp.homedomRegExp = false;
        window.wt_sp_globals.configs.plugins.sp.homesite = window.wt_sp_globals.spPageContextInfo.siteAbsoluteUrl;
        window.wt_sp_globals.configs.plugins.sp.homeweb = window.wt_sp_globals.spPageContextInfo.webAbsoluteUrl;
    }
};
/**********************MANUAL TAG CONFIG END*************************/

// Creation of WT and initial Page View
window.webtrendsAsyncInit = function () {
    dcs = new Webtrends.dcs().init(window.wt_sp_globals.configs);
    // Store Webtrends objects for MDS
    window.wt_sp_globals.Webtrends = Webtrends;
    window.wt_sp_globals.dcs = dcs;
    window.wt_sp_globals.wtBlockMDS = true;
    window.plugin = window.wt_sp_globals.pluginObj;
    window.wt_sp_globals.trackIfReady();
};

// Page View Beacon
window.wt_sp_globals.trackIfReady = function () {
    // Get user setting value if it has
    var blockPageView = window.wt_sp_globals.blockPageView || false;
    // Block Page View in some pages
    var iframeAllow = window.self === window.top;
    var URI = window.location.pathname.toLowerCase();
    var URIallow = (URI.indexOf("/wopiframe.aspx") === -1 && URI.indexOf("/itemexpiration.aspx") === -1 && URI.indexOf("/lightbox.aspx") === -1);
    if (!blockPageView && iframeAllow && URIallow) {
        dcs.track({
            finish: function (dcsObject, multiTrackObject) {
                window.wt_sp_globals.pluginObj.finishCleanup(dcsObject, multiTrackObject);
            }
        });

        // Update dcs object with new page data
        window.wt_sp_globals.dcs = dcs;
    }
};

// Reload required objects to fire Page View in MDS
window.wt_sp_globals.wtReload = function () {
    // Rebuild Webtrends objects
    window.Webtrends = window.wt_sp_globals.Webtrends;
    window.dcs = window.wt_sp_globals.dcs;

    // Reset Functions/Scripts lost in MDS transition
    if (typeof Webtrends !== "undefined") {
        if (window.wt_sp_globals.wtBlockMDS === false) {
            window.wt_sp_globals.pluginObj.resetFunctions();
        }
        window.wt_sp_globals.wtBlockMDS = true;
    }
    else {
        window.wt_sp_globals.wtLoadScript();
    }
};

// Modern View: Reload required objects to fire Page View
window.wt_sp_globals.wtReloadModernView = function () {
    // Reset Functions/Scripts for modern view single page app transition
    window.wt_sp_globals.pluginObj.resetFunctionsModernView();
};

// Load Scripts
window.wt_sp_globals.wtLoadScript = function () {
    // Check if script is already loaded
    var scripts = document.scripts;
    var scriptNotFound = true;
    for (var i = 0; i < scripts.length; i++) {
        if (scripts[i].src.indexOf("/webtrends.js") >= 0) {
            scriptNotFound = false;
            break;
        }
    }
    // Insert script
    if (scriptNotFound || (wt_sp_globals.modernView && !window.Webtrends)) {
        // Switching from Classic to Modern will sometimes leave the webtrends.js in the page,
        // but the Webtrends objects are gone - Reload
        var s = document.createElement("script");
        s.async = true;
        s.src = window.wt_sp_globals.baseTagUrl + "webtrends.js";
        var s2 = document.getElementsByTagName("script")[0];
        s2.parentNode.insertBefore(s, s2);
    }
};

// Check for MDS and push WT at end of a "page" load
if (typeof asyncDeltaManager !== "undefined") {
    asyncDeltaManager.add_endRequest(function () {
        if (typeof window.wt_sp_globals.wtBlockMDS !== "undefined") {
            _spBodyOnLoadFunctionNames.push("window.wt_sp_globals.wtReload");
        }
    });
}

// Function to register the WT namespace in MDS
window.wt_sp_globals.wtRegisterNameSpaceAfterType = function () {
    if (typeof Type !== "undefined" && typeof Type.registerNamespace === "function") {
        Type.registerNamespace("wt_sp_globals");
    }
    else {
        setTimeout(window.wt_sp_globals.wtRegisterNameSpaceAfterType, 1000);
    }
};

// Verifies required objects are available on the page to begin loading
window.wt_sp_globals.wtCheckPageStatus = function () {
    if (window._spPageContextInfo || (window.spfxPerfMarks && window.spfxPerfMarks.bodyEnd) || window.document.readyState === "complete") {
        // Build internal wt_sp_globals.spPageContextInfo
        if (!window.wt_sp_globals.spPageContextInfo) {
            if (window._spPageContextInfo) {
                window.wt_sp_globals.spPageContextInfo = window._spPageContextInfo;
            }
        }
        return true;
    }
    else return false;
};

// Function to load initial webtrends.js file after _spPageContextInfo is present
window.wt_sp_globals.wtLoadAfterPageContextInfo = function () {
    if (window.wt_sp_globals.wtCheckPageStatus()) {
        // Load manual configuration if app is not available
        if (typeof window.wt_sp_globals.wtManualLoadConfigs === "function" &&
            typeof window.wt_sp_globals.configs === "undefined") {
            window.wt_sp_globals.wtManualLoadConfigs();
        }
        window.wt_sp_globals.wtLoadScript();
    }
    else {
        setTimeout(window.wt_sp_globals.wtLoadAfterPageContextInfo, 200);
    }
};

if (!window.wt_sp_globals.modernView) {
    // Run Load functions in Classic View - App extension runs these internally
    window.wt_sp_globals.wtLoadAfterPageContextInfo();
    window.wt_sp_globals.wtRegisterNameSpaceAfterType();
}
